/****************************************************************************
*
*     Module Filename:  Realised_Cycle_Type_Manager.h
*     Module Name:      Realised_Cycle_Type_Manager
*     Description:      Represents type of Cycle that has occurred       
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*      Amendment History:- 
*
*              Version	  Date                        Update Description
*              =======    ===========                 ==================
*
*
*
*
****************************************************************************/

#ifndef Realised_Cycle_Type_H
#define Realised_Cycle_Type_H

class Tracker;

class   Realised_Cycle_Type_Manager

{
//===== Relationships with other classes ===================================================================

//==========================================================================================================

    public:
        typedef Realised_Cycle_Type_Manager RCT_Manager;

        int   Get_Num_Realised_Cycle_Types();
        void  Notify_Cycle_Occurrence(Tracker*  Tracker_Ptr, int Closing_MolType_Id) ; 
//        void  Output_Cycle_Types();
        Realised_Cycle_Type_Manager();
        static Realised_Cycle_Type_Manager*  Get_Pt();
        void  Clear();

        struct Active_Cycle_Summary
            {
             int Num_Cycle_Types;           // Number of Cycle Types that have completed since 
                                            // Last_Stats_Collection_Time
             double Avg_Length;             // Average Length of Active Cycles
             double Avg_Cycle_Rate;         // Average number of Cycles (of any type) completed per timestep
             double Avg_Interaction_Rate;   // Average Number of Interactions per timestep that 
                                            // contributed to Active Cycles
             int Min_Length;                // Minimum Length of Active Cycles
             int Max_Length;                // Maximum Length of Active Cycles
            };
        void  Get_Active_Cycle_Type_Stats(int Reactor_Time,
                                          Active_Cycle_Summary& Stats);
    private:
        int Last_Stats_Collection_Time;
        struct Realised_Cycle_Type_Params
            {int  Period_Occurrence_Counter;  // Number of Occurrences since Last_Stats_Collection_Time
            int  Last_Occurrence_Time;    
            int  Cycle_Length;
            };
        map<string,Realised_Cycle_Type_Params> Realised_Cycle_Types;
        static  Realised_Cycle_Type_Manager* Instance_Pt;
};
#endif  //Realised_Cycle_Type_H
