/****************************************************************************
*
*	  Module Filename:  User_Actions_API.cpp
*	  Module Name:      User Actions API
*	  Description:      User Interface Manager API for handling user actions
*                      
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2007, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*	  Amendment History:-
*
*         Version    Date                 Update Description
*         =======    ===========          ==================
*
*
*
*
****************************************************************************/
//  Comment out to disallow tracing this file
//#define  ENABLE_TRACE_FILE  

namespace API{ int User_Actions_API; }
  // Exists only to make KDevelop display User_Actions_API in explorer


#include  "globldef.h"
#include  "Library_Headers.h"

//--------------  User_Interface_Manager Subsystem  ------------------------------------------------------------
#include "User_Actions_API.h"
#include "Form_Main.h"
#include "Form_Simulation_Statistics.h"
#include "Form_Simulation_Control.h"
#include "Form_View_Chemistry.h"
#include "Form_View_Reactor.h"
#include "Form_Help.h"
#include "Form_System_Monitor.h"
//--------------------------------------------------------------------------------------------------------------

MainForm*                    User_Actions_API::MainForm_Ptr = 0;
Form_Help*                   User_Actions_API::Form_Help_Ptr = 0;
Form_Simulation_Statistics*  User_Actions_API::Form_SimStats_Ptr = 0;
Form_Simulation_Control*     User_Actions_API::Form_SimCtrl_Ptr = 0;
TForm__View_Chemistry*       User_Actions_API::Form_ViewChem_Ptr = 0;
TForm__View_Reactor*         User_Actions_API::Form_ViewReactor_Ptr = 0;
Form_System_Monitor*         User_Actions_API::Form_SysMon_Pt = 0;
//----------------------------------------------------------------------------------------------------------------

void  User_Actions_API::Initialise_API()

//  Initialise the pointers to the singleton objects referenced by the API

{
//    Assert(MainForm_Ptr == 0,"User_Actions_API::Initialise - MainForm_Ptr has already been Initialised");
//    MainForm_Ptr = MainForm::Get_Ptr();

    Assert(Form_SimStats_Ptr == 0,"User_Actions_API::Initialise - Form_SimStats_Ptr has already been Initialised");
    Form_SimStats_Ptr = Form_Simulation_Statistics::Get_Ptr();

    Assert(Form_SimCtrl_Ptr == 0,"User_Actions_API::Initialise - Form_SimCtrl_Ptr has already been Initialised");
    Form_SimCtrl_Ptr = Form_Simulation_Control::Get_Ptr();

    Assert(Form_ViewChem_Ptr == 0,"User_Actions_API::Initialise - Form_ViewChem_Ptr has already been Initialised");
    Form_ViewChem_Ptr = TForm__View_Chemistry::Get_Ptr();

    Assert(Form_ViewReactor_Ptr == 0,"User_Actions_API::Initialise - Form_ViewReactor_Ptr has already been Initialised");
    Form_ViewReactor_Ptr = TForm__View_Reactor::Get_Ptr();

    Assert(Form_Help_Ptr == 0,"User_Actions_API::Initialise - Form_Help_Ptr has already been Initialised");
    Form_Help_Ptr = Form_Help::Get_Ptr();

    Assert(Form_SysMon_Pt == 0,"User_Actions_API::Initialise - Form_SysMon_Pt has already been Initialised");
    Form_SysMon_Pt = Form_System_Monitor::Get_Ptr();
}
//----------------------------------------------------------------------------------------------------------------

void User_Actions_API::Form_Help_::Show_Help_Text()

{
    Form_Help_Ptr->Show_Help_Text();
}
//----------------------------------------------------------------------------------------------------------------
// void User_Actions_API::Form_SimCtrl::New_Scenario(bool  Warn_User)
// 
// //  Create a new Scenario
// 
// {
//     Form_SimCtrl_Ptr->New_Scenario(Warn_User);
// }
//----------------------imulation_Statistics------------------------------------------------------------------------------------------

void  User_Actions_API::Form_SimStats::ListView_Group_DblClick()

{
    Form_SimStats_Ptr->ListView_Group_DblClick();
}
//----------------------------------------------------------------------------------------------------------------

void  User_Actions_API::Form_SimStats::ListView_Series_DblClick()

{
    TRACE("User_Actions_API::Form_SimStats::ListView_Series_DblClick");
    Form_SimStats_Ptr->ListView_Series_DblClick();
}
//----------------------------------------------------------------------------------------------------------------

void  User_Actions_API::Form_SimStats::ListView_SerList_Select()

{
    Form_SimStats_Ptr->ListView_SerList_Select();
}
//----------------------------------------------------------------------------------------------------------------

void  User_Actions_API::Form_SimStats::Page_Select()

{
    TRACE("User_Actions_API::Form_SimStats::Page_Select");
    Form_SimStats_Ptr->Page_Select();
}
//----------------------------------------------------------------------------------------------------------------

void  User_Actions_API::Form_SysMon::Page_Select()

{
    Form_SysMon_Pt->Display_Object_Statistics();
}
//----------------------------------------------------------------------------------------------------------------

void User_Actions_API::Form_ViewChem::Notify_MolType_ListView_Selection(void*  Data_Ptr)

{
    Form_ViewChem_Ptr->Notify_MolType_ListView_Selection(Data_Ptr);
}
//----------------------------------------------------------------------------------------------------------------

void User_Actions_API::Form_ViewReactor::Notify_R_MolType_ListView_Selection(void*  Data_Ptr)

{
    Form_ViewReactor_Ptr->Notify_R_MolType_ListView_Selection(Data_Ptr);
}
//----------------------------------------------------------------------------------------------------------------

void  User_Actions_API::MainForm_::File_Exit()

{
    MainForm_Ptr->File_Exit();
}
//----------------------------------------------------------------------------------------------------------------


void  User_Actions_API::MainForm_::File_Close_Scenario()

{
    MainForm_Ptr->File_Close_Scenario();
}
//----------------------------------------------------------------------------------------------------------------

bool  User_Actions_API::MainForm_::File_Load_Scenario()

{
    return MainForm_Ptr->File_Load_Scenario();
}
//----------------------------------------------------------------------------------------------------------------

bool User_Actions_API::MainForm_::Simulation_Go_Click()

//  Attempt to strt ;simulation and return true if success

{
    return MainForm_Ptr->Simulation_Go_Click();
}
//----------------------------------------------------------------------------------------------------------------

void User_Actions_API::MainForm_::Simulation_Stop_Click()

{
    return MainForm_Ptr->Simulation_Stop_Click();
}
//----------------------------------------------------------------------------------------------------------------


