/****************************************************************************
*
*	  Module Filename:  Logger.cpp
*	  Module Name:      Logger
*	  Description:      Logging Utility, based on log4cpp
*                      
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*	  Amendment History:-
*
*         Version    Date                 Update Description
*         =======    ===========          ==================
*
*
*
*
****************************************************************************/

#include    "globldef.h"
#include    "Library_Headers.h"

namespace DN {
#include "list.hpp"        // Special purpose - Non STL
}

//-------------- log4cpp system ----------------------------------------------------------------------------------
//#include    "log4cpp/Category.hh"
//#include    "log4cpp/FileAppender.hh"
//#include    "log4cpp/SimpleLayout.hh"
//----------------------------------------------------------------------------------------------------------------

#include "Reactor.h"

//--------------  Logger  Subsystem  -----------------------------------------------------------------------------
#include  "Logger.h"
//----------------------------------------------------------------------------------------------------------------
     

using namespace std;    
   
//log4cpp::Category*  Logger::DebugCat_Ptr = 0; 


void Logger::Debug(const char*  Msg_Ptr)
{
    string Msg = (Reactor::Get_Reactor__Ptr() ? To_String(Reactor::Time()) : string("")) 
                 + string(Msg_Ptr);
    cout << Msg.c_str() << endl;
//    DebugCat_Ptr->debug(Msg.c_str());
};
//----------------------------------------------------------------------------------------------------------------

void  Logger::Make()

{
/*
//  1 instantiate an appender object that 
//  will append to a log file
    CREATE_OBJECT(log4cpp::Appender, 
                  log4cpp::Appender* Dbg_Appndr_Ptr 
                  = new  log4cpp::FileAppender("Debu_Appender",
                  "SimSoup_Debug.log"));       

//  2. Instantiate a layout object
//  Two layouts come already available in log4cpp
//  unless you create your own.
//  BasicLayout includes a time stamp
    CREATE_OBJECT(log4cpp::Layout, log4cpp::Layout* Layout_Ptr = new log4cpp::SimpleLayout());

//  3. attach the layout object to the 
//  appender object
    Dbg_Appndr_Ptr->setLayout(Layout_Ptr);

//  4. Instantiate the category object
//  you may extract the root category, but it is
//  usually more practical to directly instance
//  a child category

    DebugCat_Ptr =  &log4cpp::Category::getInstance("Debug_Categ");

// 5. Step 1 
// an Appender when added to a category becomes
// an additional output destination unless 
// Additivity is set to false when it is false,
// the appender added to the category replaces
// all previously existing appenders
   DebugCat_Ptr->setAdditivity(false);

// 5. Step 2
// this appender becomes the only one
   DebugCat_Ptr->setAppender(Dbg_Appndr_Ptr);

// 6. Set up the priority for the category
// and is given INFO priority
// attempts to log DEBUG messages will fail
   DebugCat_Ptr->setPriority(log4cpp::Priority::DEBUG);*/
}

void  Logger::Shutdown()

{


    // clean up and flush all appenders
//    log4cpp::Category::shutdown();

 
}
